1. 两数之和
暴力解法:O(N^2)
//给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
//
// 你可以假设每种输入只会对应一个答案,并且你不能使用两次相同的元素。
//
// 你可以按任意顺序返回答案。
//
//
//
// 示例 1:
//
//
//输入:nums = [2,7,11,15], target = 9
//输出:[0,1]
//解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
//
//
// 示例 2:
//
//
//输入:nums = [3,2,4], target = 6
//输出:[1,2]
//
//
// 示例 3:
//
//
//输入:nums = [3,3], target = 6
//输出:[0,1]
//
//
//
//
// 提示:
//
//
// 2 <= nums.length <= 10⁴
// -10⁹ <= nums[i] <= 10⁹
// -10⁹ <= target <= 10⁹
// 只会存在一个有效答案
//
//
//
//
// 进阶:你可以想出一个时间复杂度小于 O(n²) 的算法吗?
//
// Related Topics 数组 哈希表 👍 18845 👎 0package leetcode.editor.cn;/*** 两数之和* @author DY* @date 2024-08-28 23:31:08*/
public class P1_TwoSum {public static void main(String[] args) {//测试代码Solution solution = new P1_TwoSum().new Solution();}//力扣代码
//leetcode submit region begin(Prohibit modification and deletion)class Solution {public int[] twoSum(int[] nums, int target) {int[] result = new int[2];for (int i = 0; i < nums.length - 1; i++) {for (int j = i + 1; j < nums.length; j++) {if (nums[i] + nums[j] == target) {result = new int[]{i, j};}}}return result;}}
//leetcode submit region end(Prohibit modification and deletion)}
运行截图:
利用哈斯表查找O(n)和反向思维(变问题为寻找other=target-num[i]的位置):O(n)
//给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
//
// 你可以假设每种输入只会对应一个答案,并且你不能使用两次相同的元素。
//
// 你可以按任意顺序返回答案。
//
//
//
// 示例 1:
//
//
//输入:nums = [2,7,11,15], target = 9
//输出:[0,1]
//解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
//
//
// 示例 2:
//
//
//输入:nums = [3,2,4], target = 6
//输出:[1,2]
//
//
// 示例 3:
//
//
//输入:nums = [3,3], target = 6
//输出:[0,1]
//
//
//
//
// 提示:
//
//
// 2 <= nums.length <= 10⁴
// -10⁹ <= nums[i] <= 10⁹
// -10⁹ <= target <= 10⁹
// 只会存在一个有效答案
//
//
//
//
// 进阶:你可以想出一个时间复杂度小于 O(n²) 的算法吗?
//
// Related Topics 数组 哈希表 👍 18845 👎 0package leetcode.editor.cn;import java.util.HashMap;/*** 两数之和* @author DY* @date 2024-08-28 23:31:08*/
public class P1_TwoSum {public static void main(String[] args) {//测试代码Solution solution = new P1_TwoSum().new Solution();}//力扣代码
//leetcode submit region begin(Prohibit modification and deletion)class Solution {public int[] twoSum(int[] nums, int target) {HashMap<Integer, Integer> numMap = new HashMap<>();for (int i=0;i<nums.length;i++){int other=target-nums[i];if(numMap.containsKey(other)){return new int[]{numMap.get(other).intValue(),i};}numMap.put(nums[i],i);}return new int[]{};}}
//leetcode submit region end(Prohibit modification and deletion)}
运行截图: